# Copyright 2014-2019 Intel Corporation.
#
# This software and the related documents are Intel copyrighted  materials,  and
# your use of  them is  governed by the  express license  under which  they were
# provided to you (License).  Unless the License provides otherwise, you may not
# use, modify, copy, publish, distribute,  disclose or transmit this software or
# the related documents without Intel's prior written permission.
#
# This software and the related documents  are provided as  is,  with no express
# or implied  warranties,  other  than those  that are  expressly stated  in the
# License.



from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_prediction19_', [dirname(__file__)])
        except ImportError:
            import _prediction19_
            return _prediction19_
        if fp is not None:
            try:
                _mod = imp.load_module('_prediction19_', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _prediction19_ = swig_import_helper()
    del swig_import_helper
else:
    import _prediction19_
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


import daal.algorithms.ridge_regression
import daal.algorithms
import daal.data_management
import daal
import daal.services
import daal.data_management.features
import daal.data_management.modifiers.csv
import daal.data_management.modifiers
import daal.algorithms.linear_model
import daal.algorithms.regression
import daal.algorithms.linear_model.prediction
import daal.algorithms.regression.prediction

_prediction19_.defaultDense_swigconstant(_prediction19_)
defaultDense = _prediction19_.defaultDense

_prediction19_.data_swigconstant(_prediction19_)
data = _prediction19_.data

_prediction19_.lastNumericTableInputId_swigconstant(_prediction19_)
lastNumericTableInputId = _prediction19_.lastNumericTableInputId

_prediction19_.model_swigconstant(_prediction19_)
model = _prediction19_.model

_prediction19_.lastModelInputId_swigconstant(_prediction19_)
lastModelInputId = _prediction19_.lastModelInputId

_prediction19_.prediction_swigconstant(_prediction19_)
prediction = _prediction19_.prediction

_prediction19_.lastResultId_swigconstant(_prediction19_)
lastResultId = _prediction19_.lastResultId
class Input(daal.algorithms.linear_model.prediction.Input):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.linear_model.prediction.Input]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Input, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.linear_model.prediction.Input]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Input, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _prediction19_.new_Input(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getTable(self, id):
        return _prediction19_.Input_getTable(self, id)

    def getModel(self, id):
        return _prediction19_.Input_getModel(self, id)

    def setTable(self, id, value):
        return _prediction19_.Input_setTable(self, id, value)

    def setModel(self, id, value):
        return _prediction19_.Input_setModel(self, id, value)
    __swig_destroy__ = _prediction19_.delete_Input
    __del__ = lambda self: None
Input_swigregister = _prediction19_.Input_swigregister
Input_swigregister(Input)

class Result(daal.algorithms.linear_model.prediction.Result):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.linear_model.prediction.Result]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Result, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.linear_model.prediction.Result]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Result, name)
    __repr__ = _swig_repr
    __swig_getmethods__["serializationTag"] = lambda x: _prediction19_.Result_serializationTag
    if _newclass:
        serializationTag = staticmethod(_prediction19_.Result_serializationTag)

    def getSerializationTag(self):
        return _prediction19_.Result_getSerializationTag(self)

    def __init__(self):
        this = _prediction19_.new_Result()
        try:
            self.this.append(this)
        except:
            self.this = this

    def get(self, id):
        return _prediction19_.Result_get(self, id)

    def set(self, id, value):
        return _prediction19_.Result_set(self, id, value)
    __swig_destroy__ = _prediction19_.delete_Result
    __del__ = lambda self: None
Result_swigregister = _prediction19_.Result_swigregister
Result_swigregister(Result)

def Result_serializationTag():
    return _prediction19_.Result_serializationTag()
Result_serializationTag = _prediction19_.Result_serializationTag

class Batch_Float64DefaultDense(daal.algorithms.linear_model.prediction.Batch_Float64DefaultDense):
    r"""
    This class is an alias of Batch()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.linear_model.prediction.Batch_Float64DefaultDense]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float64DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.linear_model.prediction.Batch_Float64DefaultDense]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float64DefaultDense, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _prediction19_.Batch_Float64DefaultDense_input_set
    __swig_getmethods__["input"] = _prediction19_.Batch_Float64DefaultDense_input_get
    if _newclass:
        input = _swig_property(_prediction19_.Batch_Float64DefaultDense_input_get, _prediction19_.Batch_Float64DefaultDense_input_set)

    def __init__(self, *args):
        this = _prediction19_.new_Batch_Float64DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getMethod(self):
        return _prediction19_.Batch_Float64DefaultDense_getMethod(self)

    def getResult(self):
        return _prediction19_.Batch_Float64DefaultDense_getResult(self)

    def clone(self):
        return _prediction19_.Batch_Float64DefaultDense_clone(self)

    def getInput(self):
        return _prediction19_.Batch_Float64DefaultDense_getInput(self)
    __swig_destroy__ = _prediction19_.delete_Batch_Float64DefaultDense
    __del__ = lambda self: None
Batch_Float64DefaultDense_swigregister = _prediction19_.Batch_Float64DefaultDense_swigregister
Batch_Float64DefaultDense_swigregister(Batch_Float64DefaultDense)

class Batch_Float32DefaultDense(daal.algorithms.linear_model.prediction.Batch_Float32DefaultDense):
    r"""
    This class is an alias of Batch()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.linear_model.prediction.Batch_Float32DefaultDense]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float32DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.linear_model.prediction.Batch_Float32DefaultDense]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float32DefaultDense, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _prediction19_.Batch_Float32DefaultDense_input_set
    __swig_getmethods__["input"] = _prediction19_.Batch_Float32DefaultDense_input_get
    if _newclass:
        input = _swig_property(_prediction19_.Batch_Float32DefaultDense_input_get, _prediction19_.Batch_Float32DefaultDense_input_set)

    def __init__(self, *args):
        this = _prediction19_.new_Batch_Float32DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getMethod(self):
        return _prediction19_.Batch_Float32DefaultDense_getMethod(self)

    def getResult(self):
        return _prediction19_.Batch_Float32DefaultDense_getResult(self)

    def clone(self):
        return _prediction19_.Batch_Float32DefaultDense_clone(self)

    def getInput(self):
        return _prediction19_.Batch_Float32DefaultDense_getInput(self)
    __swig_destroy__ = _prediction19_.delete_Batch_Float32DefaultDense
    __del__ = lambda self: None
Batch_Float32DefaultDense_swigregister = _prediction19_.Batch_Float32DefaultDense_swigregister
Batch_Float32DefaultDense_swigregister(Batch_Float32DefaultDense)

from numpy import float64, float32, intc

class Batch(object):
    r"""Factory class for different types of Batch."""
    def __new__(cls,
                *args, **kwargs):
        if 'fptype' not in kwargs or kwargs['fptype'] == float64:
            if 'method' not in kwargs or kwargs['method'] == defaultDense:
                return Batch_Float64DefaultDense(*args)
        if 'fptype' in kwargs and kwargs['fptype'] == float32:
            if 'method' not in kwargs or kwargs['method'] == defaultDense:
                return Batch_Float32DefaultDense(*args)

        raise RuntimeError("No appropriate constructor found for Batch")


# This file is compatible with both classic and new-style classes.


